Index: sys/net/if_sl.c
===================================================================
RCS file: /home/ncvs/src/sys/net/if_sl.c,v
retrieving revision 1.92
diff -u -r1.92 if_sl.c
--- sys/net/if_sl.c	2000/12/21 21:43:45	1.92
+++ sys/net/if_sl.c	2001/01/05 17:42:12
@@ -328,9 +328,10 @@
 	register struct sl_softc *sc;
 	int s, error;
 
-	error = suser(p);
+	error = cap_check(NULL, p, CAP_NET_ADMIN, 0);
 	if (error)
 		return (error);
+	suser_used(p);
 
 	if (tp->t_line == SLIPDISC)
 		return (0);
Index: sys/net/if_tap.c
===================================================================
RCS file: /home/ncvs/src/sys/net/if_tap.c,v
retrieving revision 1.5
diff -u -r1.5 if_tap.c
--- sys/net/if_tap.c	2000/12/08 21:50:44	1.5
+++ sys/net/if_tap.c	2000/12/13 05:38:17
@@ -271,8 +271,9 @@
 	struct tap_softc	*tp = NULL;
 	int			 error;
 
-	if ((error = suser(p)) != 0)
+	if ((error = cap_check(NULL, p, CAP_NET_ADMIN, 0)) != 0)
 		return (error);
+	suser_used(p);
 
 	tp = dev->si_drv1;
 	if (tp == NULL) {
Index: sys/net/if_tun.c
===================================================================
RCS file: /home/ncvs/src/sys/net/if_tun.c,v
retrieving revision 1.83
diff -u -r1.83 if_tun.c
--- sys/net/if_tun.c	2000/12/08 21:50:44	1.83
+++ sys/net/if_tun.c	2000/12/13 05:38:18
@@ -180,9 +180,10 @@
 	struct tun_softc *tp;
 	register int	error;
 
-	error = suser(p);
+	error = cap_check(NULL, p, CAP_NET_ADMIN, 0);
 	if (error)
 		return (error);
+	suser_used(p);
 
 	tp = dev->si_drv1;
 	if (!tp) {
Index: sys/net/ppp_tty.c
===================================================================
RCS file: /home/ncvs/src/sys/net/ppp_tty.c,v
retrieving revision 1.46
diff -u -r1.46 ppp_tty.c
--- sys/net/ppp_tty.c	2000/12/21 21:43:45	1.46
+++ sys/net/ppp_tty.c	2001/01/05 17:42:12
@@ -175,8 +175,9 @@
     register struct ppp_softc *sc;
     int error, s;
 
-    if ((error = suser(p)) != 0)
+    if ((error = cap_check(NULL, p, CAP_NET_ADMIN, 0)) != 0)
 	return (error);
+    suser_used(p);
 
     s = spltty();
 
@@ -444,8 +445,9 @@
     error = 0;
     switch (cmd) {
     case PPPIOCSASYNCMAP:
-	if ((error = suser(p)) != 0)
+	if ((error = cap_check(NULL, p, CAP_NET_ADMIN, 0)) != 0)
 	    break;
+	suser_used(p);
 	sc->sc_asyncmap[0] = *(u_int *)data;
 	break;
 
@@ -454,8 +456,9 @@
 	break;
 
     case PPPIOCSRASYNCMAP:
-	if ((error = suser(p)) != 0)
+	if ((error = cap_check(NULL, p, CAP_NET_ADMIN, 0)) != 0)
 	    break;
+	suser_used(p);
 	sc->sc_rasyncmap = *(u_int *)data;
 	break;
 
@@ -464,8 +467,9 @@
 	break;
 
     case PPPIOCSXASYNCMAP:
-	if ((error = suser(p)) != 0)
+	if ((error = cap_check(NULL, p, CAP_NET_ADMIN, 0)) != 0)
 	    break;
+	suser_used(p);
 	s = spltty();
 	bcopy(data, sc->sc_asyncmap, sizeof(sc->sc_asyncmap));
 	sc->sc_asyncmap[1] = 0;		    /* mustn't escape 0x20 - 0x3f */
Index: sys/net/raw_usrreq.c
===================================================================
RCS file: /home/ncvs/src/sys/net/raw_usrreq.c,v
retrieving revision 1.19
diff -u -r1.19 raw_usrreq.c
--- sys/net/raw_usrreq.c	2000/10/29 16:06:43	1.19
+++ sys/net/raw_usrreq.c	2000/11/07 02:45:17
@@ -157,8 +157,9 @@
 
 	if (rp == 0)
 		return EINVAL;
-	if (p && (error = suser(p)) != 0)
+	if (p && (error = cap_check(NULL, p, CAP_NET_RAW, 0)) != 0)
 		return error;
+	suser_used(p);
 	return raw_attach(so, proto);
 }
 
Index: sys/netatalk/at_control.c
===================================================================
RCS file: /home/ncvs/src/sys/netatalk/at_control.c,v
retrieving revision 1.29
diff -u -r1.29 at_control.c
--- sys/netatalk/at_control.c	2000/12/08 21:50:45	1.29
+++ sys/netatalk/at_control.c	2000/12/13 05:38:19
@@ -11,6 +11,7 @@
 #include <sys/malloc.h>
 #include <sys/kernel.h>
 #include <sys/socket.h>
+#include <sys/capability.h>
 #include <net/if.h>
 #include <net/route.h>
 #include <netinet/in.h>
@@ -52,6 +53,7 @@
     struct at_ifaddr	*aa0;
     struct at_ifaddr	*aa = 0;
     struct ifaddr	*ifa, *ifa0;
+    int			error;
 
     /*
      * If we have an ifp, then find the matching at_ifaddr if it exists
@@ -99,9 +101,10 @@
 	/* 
 	 * If we are not superuser, then we don't get to do these ops.
 	 */
-	if ( suser(p) ) {
-	    return( EPERM );
+	if ((error = cap_check(NULL, p, CAP_NET_ADMIN, 0)) != 0) {
+	    return( error );
 	}
+	suser_used(p);
 
 	sat = satosat( &ifr->ifr_addr );
 	nr = (struct netrange *)sat->sat_zero;
Index: sys/netatalk/ddp_usrreq.c
===================================================================
RCS file: /home/ncvs/src/sys/netatalk/ddp_usrreq.c,v
retrieving revision 1.20
diff -u -r1.20 ddp_usrreq.c
--- sys/netatalk/ddp_usrreq.c	2000/12/08 21:50:45	1.20
+++ sys/netatalk/ddp_usrreq.c	2000/12/13 05:38:19
@@ -12,6 +12,7 @@
 #include <sys/socket.h>
 #include <sys/socketvar.h>
 #include <sys/protosw.h>
+#include <sys/capability.h>
 #include <net/if.h>
 #include <net/route.h>
 
@@ -253,8 +254,9 @@
 		return( EINVAL );
 	    }
 	    if ( sat->sat_port < ATPORT_RESERVED &&
-		 suser(p) ) {
+		 cap_check(NULL, p, CAP_NET_BIND_SERVICE, 0) ) {
 		return( EACCES );
+		suser_used(p);
 	    }
 	}
     } else {
Index: sys/netatm/atm_usrreq.c
===================================================================
RCS file: /home/ncvs/src/sys/netatm/atm_usrreq.c,v
retrieving revision 1.11
diff -u -r1.11 atm_usrreq.c
--- sys/netatm/atm_usrreq.c	2000/12/07 22:19:04	1.11
+++ sys/netatm/atm_usrreq.c	2000/12/13 05:38:20
@@ -192,8 +192,11 @@
 		struct atmcfgreq	*acp = (struct atmcfgreq *)data;
 		struct atm_pif		*pip;
 
-		if (p && (suser(p) != 0))
-			ATM_RETERR(EPERM);
+		if (p) {
+			if ((err = cap_check(NULL, p, CAP_NET_ADMIN, 0)) != 0)
+				ATM_RETERR(err);
+			suser_used(p);
+		}
 
 		switch (acp->acr_opcode) {
 
@@ -225,8 +228,11 @@
 		struct atmaddreq	*aap = (struct atmaddreq *)data;
 		Atm_endpoint		*epp;
 
-		if (p && (suser(p) != 0))
-			ATM_RETERR(EPERM);
+		if (p) {
+			if ((err = cap_check(NULL, p, CAP_NET_ADMIN, 0)) != 0)
+				ATM_RETERR(err);
+			suser_used(p);
+		}
 
 		switch (aap->aar_opcode) {
 
@@ -275,8 +281,11 @@
 		struct sigmgr		*smp;
 		Atm_endpoint		*epp;
 
-		if (p && (suser(p) != 0))
-			ATM_RETERR(EPERM);
+		if (p) {
+			if ((err = cap_check(NULL, p, CAP_NET_ADMIN, 0)) != 0)
+				ATM_RETERR(err);
+			suser_used(p);
+		}
 
 		switch (adp->adr_opcode) {
 
@@ -328,8 +337,11 @@
 		struct sigmgr		*smp;
 		struct ifnet		*ifp2;
 
-		if (p && (suser(p) != 0))
-			ATM_RETERR(EPERM);
+		if (p) {
+			if ((err = cap_check(NULL, p, CAP_NET_ADMIN, 0)) != 0)
+				ATM_RETERR(err);
+			suser_used(p);
+		}
 
 		switch (asp->asr_opcode) {
 
Index: sys/netgraph/ng_socket.c
===================================================================
RCS file: /home/ncvs/src/sys/netgraph/ng_socket.c,v
retrieving revision 1.20
diff -u -r1.20 ng_socket.c
--- sys/netgraph/ng_socket.c	2000/12/18 20:03:32	1.20
+++ sys/netgraph/ng_socket.c	2001/01/05 17:42:19
@@ -157,9 +157,11 @@
 ngc_attach(struct socket *so, int proto, struct proc *p)
 {
 	struct ngpcb *const pcbp = sotongpcb(so);
+	int	error;
 
-	if (suser(p))
-		return (EPERM);
+	if ((error = cap_check(NULL, p, CAP_NET_ADMIN, 0)) != 0)
+		return (error);
+	suser_used(p);
 	if (pcbp != NULL)
 		return (EISCONN);
 	return (ng_attach_cntl(so));
Index: sys/netgraph/ng_tty.c
===================================================================
RCS file: /home/ncvs/src/sys/netgraph/ng_tty.c,v
retrieving revision 1.16
diff -u -r1.16 ng_tty.c
--- sys/netgraph/ng_tty.c	2000/12/18 20:03:32	1.16
+++ sys/netgraph/ng_tty.c	2001/01/05 17:42:19
@@ -195,8 +195,10 @@
 	int s, error;
 
 	/* Super-user only */
-	if ((error = suser(p)))
+	/* XXX perhaps this should be CAP_SYS_TTY_CONFIG? */
+	if ((error = cap_check(NULL, p, CAP_NET_ADMIN, 0)) != 0)
 		return (error);
+	suser_used(p);
 	s = splnet();
 	(void) spltty();	/* XXX is this necessary? */
 
Index: sys/netinet/in.c
===================================================================
RCS file: /home/ncvs/src/sys/netinet/in.c,v
retrieving revision 1.48
diff -u -r1.48 in.c
--- sys/netinet/in.c	2000/12/08 21:50:46	1.48
+++ sys/netinet/in.c	2000/12/13 05:38:27
@@ -207,9 +207,12 @@
                 switch (cmd) {
                 case SIOCSIFPHYADDR:
 		case SIOCDIFPHYADDR:
-			if (p &&
-			    (error = suser(p)) != 0)
-        			return(error);
+			if (p) {
+				if ((error = cap_check(NULL, p, CAP_NET_ADMIN,
+				    0)) != 0)
+        				return(error);
+				suser_used(p);
+			}
                 case SIOCGIFPSRCADDR:
                 case SIOCGIFPDSTADDR:
                         return gif_ioctl(ifp, cmd, data);
@@ -220,8 +223,11 @@
 	switch (cmd) {
 	case SIOCALIFADDR:
 	case SIOCDLIFADDR:
-		if (p && (error = suser(p)) != 0)
-			return error;
+		if (p) {
+			if ((error = cap_check(NULL, p, CAP_NET_ADMIN, 0)) != 0)
+				return error;
+			suser_used(p);
+		}
 		/*fall through*/
 	case SIOCGLIFADDR:
 		if (!ifp)
@@ -276,8 +282,11 @@
 	case SIOCSIFADDR:
 	case SIOCSIFNETMASK:
 	case SIOCSIFDSTADDR:
-		if (p && (error = suser(p)) != 0)
-			return error;
+		if (p) {
+			if ((error = cap_check(NULL, p, CAP_NET_ADMIN, 0)) != 0)
+				return error;
+			suser_used(p);
+		}
 
 		if (ifp == 0)
 			return (EADDRNOTAVAIL);
@@ -312,8 +321,11 @@
 		break;
 
 	case SIOCSIFBRDADDR:
-		if (p && (error = suser(p)) != 0)
-			return error;
+		if (p) {
+			if ((error = cap_check(NULL, p, CAP_NET_ADMIN, 0)) != 0)
+				return error;
+			suser_used(p);
+		}
 		/* FALLTHROUGH */
 
 	case SIOCGIFADDR:
Index: sys/netinet/in_pcb.c
===================================================================
RCS file: /home/ncvs/src/sys/netinet/in_pcb.c,v
retrieving revision 1.71
diff -u -r1.71 in_pcb.c
--- sys/netinet/in_pcb.c	2000/12/27 03:02:29	1.71
+++ sys/netinet/in_pcb.c	2001/01/05 17:42:20
@@ -49,6 +49,7 @@
 #include <sys/jail.h>
 #include <sys/kernel.h>
 #include <sys/sysctl.h>
+#include <sys/capability.h>
 
 #include <machine/limits.h>
 
@@ -221,9 +222,12 @@
 			struct inpcb *t;
 
 			/* GROSS */
-			if (ntohs(lport) < IPPORT_RESERVED && p &&
-			    suser_xxx(0, p, PRISON_ROOT))
-				return (EACCES);
+			if (ntohs(lport) < IPPORT_RESERVED && p) {
+				if (cap_check(NULL, p, CAP_NET_BIND_SERVICE,
+				    PRISON_ROOT))
+					return (EACCES);
+				suser_used(p);
+			}
 			if (p && p->p_prison)
 				prison = 1;
 			if (so->so_cred->cr_uid != 0 &&
@@ -283,8 +287,12 @@
 			last  = ipport_hilastauto;
 			lastport = &pcbinfo->lasthi;
 		} else if (inp->inp_flags & INP_LOWPORT) {
-			if (p && (error = suser_xxx(0, p, PRISON_ROOT)))
-				return error;
+			if (p) {
+				if ((error = cap_check(NULL, p,
+				    CAP_NET_BIND_SERVICE, PRISON_ROOT)))
+					return error;
+				suser_used(p);
+			}
 			first = ipport_lowfirstauto;	/* 1023 */
 			last  = ipport_lowlastauto;	/* 600 */
 			lastport = &pcbinfo->lastlow;
Index: sys/netinet/ip_divert.c
===================================================================
RCS file: /home/ncvs/src/sys/netinet/ip_divert.c,v
retrieving revision 1.48
diff -u -r1.48 ip_divert.c
--- sys/netinet/ip_divert.c	2000/10/29 16:06:47	1.48
+++ sys/netinet/ip_divert.c	2000/11/07 02:46:01
@@ -344,8 +344,11 @@
 	inp  = sotoinpcb(so);
 	if (inp)
 		panic("div_attach");
-	if (p && (error = suser(p)) != 0)
-		return error;
+	if (p) {
+		if ((error = cap_check(NULL, p, CAP_NET_RAW, 0)) != 0)
+			return error;
+		suser_used(p);
+	}
 
 	error = soreserve(so, div_sendspace, div_recvspace);
 	if (error)
Index: sys/netinet/ip_output.c
===================================================================
RCS file: /home/ncvs/src/sys/netinet/ip_output.c,v
retrieving revision 1.117
diff -u -r1.117 ip_output.c
--- sys/netinet/ip_output.c	2000/12/21 21:44:01	1.117
+++ sys/netinet/ip_output.c	2001/01/05 17:42:21
@@ -1231,8 +1231,14 @@
 				break;
 			if ((error = soopt_mcopyin(sopt, m)) != 0) /* XXX */
 				break;
-			priv = (sopt->sopt_p != NULL &&
-				suser(sopt->sopt_p) != 0) ? 0 : 1;
+			if (sopt->sopt_p != NULL) {
+				if (cap_check(sopt->sopt_p, CAP_NET_ADMIN))
+					priv = 0;
+				else {
+					priv = 1;
+					suser_used(sopt->sopt_p);
+				}
+			}
 			req = mtod(m, caddr_t);
 			len = m->m_len;
 			optname = sopt->sopt_name;
Index: sys/netinet/raw_ip.c
===================================================================
RCS file: /home/ncvs/src/sys/netinet/raw_ip.c,v
retrieving revision 1.72
diff -u -r1.72 raw_ip.c
--- sys/netinet/raw_ip.c	2000/12/21 21:44:02	1.72
+++ sys/netinet/raw_ip.c	2001/01/05 17:42:22
@@ -46,6 +46,7 @@
 #include <sys/socket.h>
 #include <sys/socketvar.h>
 #include <sys/sysctl.h>
+#include <sys/capability.h>
 
 #include <vm/vm_zone.h>
 
@@ -444,8 +445,11 @@
 	inp = sotoinpcb(so);
 	if (inp)
 		panic("rip_attach");
-	if (p && (error = suser(p)) != 0)
-		return error;
+	if (p) {
+		if ((error = cap_check(NULL, p, CAP_NET_RAW, 0)) != 0)
+			return error;
+		suser_used(p);
+	}
 
 	error = soreserve(so, rip_sendspace, rip_recvspace);
 	if (error)
Index: sys/netinet/tcp_subr.c
===================================================================
RCS file: /home/ncvs/src/sys/netinet/tcp_subr.c,v
retrieving revision 1.86
diff -u -r1.86 tcp_subr.c
--- sys/netinet/tcp_subr.c	2000/12/24 10:57:21	1.86
+++ sys/netinet/tcp_subr.c	2001/01/05 17:42:22
@@ -897,9 +897,11 @@
 	struct inpcb *inp;
 	int error, s;
 
-	error = suser(req->p);
+	/* XXX Why bother check for privilege here? */
+	error = cap_check(NULL, req->p, CAP_SYS_ADMIN, 0);
 	if (error)
 		return (error);
+	suser_used(req->p);
 	error = SYSCTL_IN(req, addrs, sizeof(addrs));
 	if (error)
 		return (error);
@@ -927,9 +929,11 @@
 	struct inpcb *inp;
 	int error, s, mapped = 0;
 
-	error = suser(req->p);
+	/* XXX Why bother check for privilege here? */
+	error = cap_check(NULL, req->p, CAP_SYS_ADMIN, 0);
 	if (error)
 		return (error);
+	suser_used(req->p);
 	error = SYSCTL_IN(req, addrs, sizeof(addrs));
 	if (error)
 		return (error);
Index: sys/netinet/udp_usrreq.c
===================================================================
RCS file: /home/ncvs/src/sys/netinet/udp_usrreq.c,v
retrieving revision 1.80
diff -u -r1.80 udp_usrreq.c
--- sys/netinet/udp_usrreq.c	2000/12/24 10:57:21	1.80
+++ sys/netinet/udp_usrreq.c	2001/01/05 17:42:22
@@ -610,9 +610,10 @@
 	struct inpcb *inp;
 	int error, s;
 
-	error = suser(req->p);
+	error = cap_check(NULL, req->p, CAP_SYS_ADMIN, 0);
 	if (error)
 		return (error);
+	suser_used(req->p);
 	error = SYSCTL_IN(req, addrs, sizeof(addrs));
 	if (error)
 		return (error);
Index: sys/netinet6/in6.c
===================================================================
RCS file: /home/ncvs/src/sys/netinet6/in6.c,v
retrieving revision 1.10
diff -u -r1.10 in6.c
--- sys/netinet6/in6.c	2000/07/12 05:20:41	1.10
+++ sys/netinet6/in6.c	2000/09/17 15:14:47
@@ -337,7 +337,7 @@
 	int privileged;
 
 	privileged = 0;
-	if (p == NULL || !suser(p))
+	if (p == NULL || !cap_check(NULL, p, CAP_NET_ADMIN, 0))
 		privileged++;
 
 	/*
@@ -349,6 +349,8 @@
 		case SIOCSIFPHYADDR_IN6:
 			if (!privileged)
 				return(EPERM);
+			if (p)
+				suser_used(p);
 			/*fall through*/
 		case SIOCGIFPSRCADDR_IN6:
 		case SIOCGIFPDSTADDR_IN6:
@@ -373,6 +375,8 @@
 	case SIOCSIFINFO_FLAGS:
 		if (!privileged)
 			return(EPERM);
+		if (p)
+			suser_used(p);
 		/*fall through*/
 	case SIOCGIFINFO_IN6:
 	case SIOCGDRLST_IN6:
@@ -390,6 +394,8 @@
 	case SIOCSGIFPREFIX_IN6:
 		if (!privileged)
 			return(EPERM);
+		if (p)
+			suser_used(p);
 		/*fall through*/
 	case SIOCGIFPREFIX_IN6:
 		if (ip6_forwarding == 0)
@@ -401,6 +407,8 @@
 	case SIOCSSCOPE6:
 		if (!privileged)
 			return(EPERM);
+		if (p)
+			suser_used(p);
 		return(scope6_set(ifp, ifr->ifr_ifru.ifru_scope_id));
 		break;
 	case SIOCGSCOPE6:
@@ -416,6 +424,8 @@
 	case SIOCDLIFADDR:
 		if (!privileged)
 			return(EPERM);
+		if (p)
+			suser_used(p);
 		/*fall through*/
 	case SIOCGLIFADDR:
 		return in6_lifaddr_ioctl(so, cmd, data, ifp, p);
@@ -475,6 +485,8 @@
 			return(EAFNOSUPPORT);
 		if (!privileged)
 			return(EPERM);
+		if (p)
+			suser_used(p);
 		if (ia == NULL) {
 			ia = (struct in6_ifaddr *)
 				malloc(sizeof(*ia), M_IFADDR, M_WAITOK);
@@ -553,6 +565,8 @@
 
 		if (!privileged)
 			return(EPERM);
+		if (p)
+			suser_used(p);
 		if (ia == NULL)
 			return(EADDRNOTAVAIL);
 		/* sanity for overflow - beware unsigned */
Index: sys/netinet6/in6_pcb.c
===================================================================
RCS file: /home/ncvs/src/sys/netinet6/in6_pcb.c,v
retrieving revision 1.13
diff -u -r1.13 in6_pcb.c
--- sys/netinet6/in6_pcb.c	2000/07/04 16:35:09	1.13
+++ sys/netinet6/in6_pcb.c	2000/09/17 15:15:16
@@ -177,10 +177,15 @@
 			struct inpcb *t;
 
 			/* GROSS */
-			if (ntohs(lport) < IPV6PORT_RESERVED && p &&
-			    suser_xxx(0, p, PRISON_ROOT))
-				return(EACCES);
-			if (so->so_cred->cr_uid != 0 &&
+			if (ntohs(lport) < IPV6PORT_RESERVED && p) {
+				if (cap_check(NULL, p, CAP_NET_BIND_SERVICE,
+				    PRISON_ROOT))
+					return(EACCES);
+				suser_used(p);
+			}
+			/* XXX setting suser_used() in this check is hard */
+			if (cap_check(so->so_cred, NULL, CAP_NET_ADMIN,
+			    PRISON_ROOT) &&
 			    !IN6_IS_ADDR_MULTICAST(&sin6->sin6_addr)) {
 				t = in6_pcblookup_local(pcbinfo,
 				    &sin6->sin6_addr, lport,
Index: sys/netinet6/in6_src.c
===================================================================
RCS file: /home/ncvs/src/sys/netinet6/in6_src.c,v
retrieving revision 1.2
diff -u -r1.2 in6_src.c
--- sys/netinet6/in6_src.c	2000/10/29 16:06:48	1.2
+++ sys/netinet6/in6_src.c	2000/11/07 02:46:12
@@ -345,8 +345,12 @@
 		last  = ipport_hilastauto;
 		lastport = &pcbinfo->lasthi;
 	} else if (inp->inp_flags & INP_LOWPORT) {
-		if (p && (error = suser(p)))
-			return error;
+		if (p) {
+			if ((error = cap_check(NULL, p, CAP_NET_BIND_SERVICE,
+			    0)) != 0)
+				return error;
+			suser_used(p);
+		}
 		first = ipport_lowfirstauto;	/* 1023 */
 		last  = ipport_lowlastauto;	/* 600 */
 		lastport = &pcbinfo->lastlow;
Index: sys/netinet6/ip6_input.c
===================================================================
RCS file: /home/ncvs/src/sys/netinet6/ip6_input.c,v
retrieving revision 1.19
diff -u -r1.19 ip6_input.c
--- sys/netinet6/ip6_input.c	2000/11/25 07:35:34	1.19
+++ sys/netinet6/ip6_input.c	2000/12/13 05:38:30
@@ -940,7 +940,7 @@
 	int privileged;
 
 	privileged = 0;
-	if (p && !suser(p))
+	if (p && !cap_check(NULL, p, CAP_NET_ADMIN, 0))
 		privileged++;
 
 	if (in6p->in6p_socket->so_options & SO_TIMESTAMP) {
@@ -1005,6 +1005,7 @@
 			struct ip6_hbh *hbh;
 			int hbhlen;
 
+			suser_used(p);
 #ifndef PULLDOWN_TEST
 			hbh = (struct ip6_hbh *)(ip6 + 1);
 			hbhlen = (hbh->ip6h_len + 1) << 3;
@@ -1089,6 +1090,7 @@
 				  */
 				 if (!privileged)
 					 break;
+				suser_used(p);
 
 				 *mp = sbcreatecontrol((caddr_t)ip6e, elen,
 						       IPV6_DSTOPTS,
Index: sys/netinet6/ip6_output.c
===================================================================
RCS file: /home/ncvs/src/sys/netinet6/ip6_output.c,v
retrieving revision 1.22
diff -u -r1.22 ip6_output.c
--- sys/netinet6/ip6_output.c	2000/12/21 21:44:10	1.22
+++ sys/netinet6/ip6_output.c	2001/01/05 17:42:24
@@ -1223,7 +1223,8 @@
 	}
 	error = optval = 0;
 
-	privileged = (p == 0 || suser(p)) ? 0 : 1;
+	/* XXX Should this be CAP_NET_ADMIN or CAP_NET_RAW? */
+	privileged = (p == 0 || cap_check(NULL, p, CAP_NET_ADMIN, 0)) ? 0 : 1;
 
 	if (level == IPPROTO_IPV6) {
 		switch (op) {
@@ -1248,6 +1249,7 @@
 					error = EPERM;
 					break;
 				}
+				suser_used(p);
 				/* fall through */
 			case IPV6_UNICAST_HOPS:
 			case IPV6_PKTINFO:
@@ -1388,6 +1390,7 @@
 					req = mtod(m, caddr_t);
 					len = m->m_len;
 				}
+				/* XXX can't set suser_used here */
 				error = ipsec6_set_policy(in6p, optname, req,
 				                          len, privileged);
 				m_freem(m);
@@ -1439,6 +1442,7 @@
 					error = EPERM;
 					break;
 				}
+				suser_used(p);
 				/* fall through */
 			case IPV6_UNICAST_HOPS:
 			case IPV6_PKTINFO:
@@ -1614,7 +1618,8 @@
 	}
 
 	/*  set options specified by user. */
-	if (p && !suser(p))
+	/* XXX Should this be CAP_NET_ADMIN or CAP_NET_RAW? */
+	if (p && !cap_check(NULL, p, CAP_NET_ADMIN, 0))
 		priv = 1;
 	if ((error = ip6_setpktoptions(m, opt, priv)) != 0) {
 		(void)m_free(m);
@@ -1732,11 +1737,12 @@
 			 * all multicast addresses. Only super user is allowed
 			 * to do this.
 			 */
-			if (suser(p))
+			if (cap_check(NULL, p, CAP_NET_BIND_SERVICE, 0))
 			{
 				error = EACCES;
 				break;
 			}
+			suser_used(p);
 		} else if (!IN6_IS_ADDR_MULTICAST(&mreq->ipv6mr_multiaddr)) {
 			error = EINVAL;
 			break;
@@ -1839,10 +1845,11 @@
 		}
 		mreq = mtod(m, struct ipv6_mreq *);
 		if (IN6_IS_ADDR_UNSPECIFIED(&mreq->ipv6mr_multiaddr)) {
-			if (suser(p)) {
+			if (cap_check(NULL, p, CAP_NET_BIND_SERVICE, 0)) {
 				error = EACCES;
 				break;
 			}
+			suser_used(p);
 		} else if (!IN6_IS_ADDR_MULTICAST(&mreq->ipv6mr_multiaddr)) {
 			error = EINVAL;
 			break;
Index: sys/netinet6/raw_ip6.c
===================================================================
RCS file: /home/ncvs/src/sys/netinet6/raw_ip6.c,v
retrieving revision 1.10
diff -u -r1.10 raw_ip6.c
--- sys/netinet6/raw_ip6.c	2000/12/21 21:44:10	1.10
+++ sys/netinet6/raw_ip6.c	2001/01/05 17:42:24
@@ -525,8 +525,11 @@
 	inp = sotoinpcb(so);
 	if (inp)
 		panic("rip6_attach");
-	if (p && (error = suser(p)) != 0)
-		return error;
+	if (p) {
+		if ((error = cap_check(NULL, p, CAP_NET_RAW, 0)) != 0)
+			return error;
+		suser_used(p);
+	}
 
 	error = soreserve(so, rip_sendspace, rip_recvspace);
 	if (error)
Index: sys/netinet6/udp6_output.c
===================================================================
RCS file: /home/ncvs/src/sys/netinet6/udp6_output.c,v
retrieving revision 1.2
diff -u -r1.2 udp6_output.c
--- sys/netinet6/udp6_output.c	2000/10/29 16:06:49	1.2
+++ sys/netinet6/udp6_output.c	2000/11/07 02:46:17
@@ -140,7 +140,8 @@
 	struct sockaddr_in6 tmp;
 
 	priv = 0;
-	if (p && !suser(p))
+	/* XXX Should this be CAP_NET_ADMIN or CAP_NET_RAW? */
+	if (p && !cap_check(NULL, p, CAP_NET_ADMIN, 0))
 		priv = 1;
 	if (control) {
 		if ((error = ip6_setpktoptions(control, &opt, priv)) != 0)
Index: sys/netinet6/udp6_usrreq.c
===================================================================
RCS file: /home/ncvs/src/sys/netinet6/udp6_usrreq.c,v
retrieving revision 1.13
diff -u -r1.13 udp6_usrreq.c
--- sys/netinet6/udp6_usrreq.c	2000/10/23 07:11:01	1.13
+++ sys/netinet6/udp6_usrreq.c	2000/11/07 02:46:17
@@ -478,9 +478,11 @@
 	struct inpcb *inp;
 	int error, s;
 
-	error = suser(req->p);
+	/* XXX Should this be CAP_NET_ADMIN or CAP_NET_RAW? */
+	error = cap_check(NULL, req->p, CAP_NET_ADMIN, 0);
 	if (error)
 		return (error);
+	suser_used(req->p);
 
 	if (req->newlen != sizeof(addrs))
 		return (EINVAL);
Index: sys/netipx/ipx.c
===================================================================
RCS file: /home/ncvs/src/sys/netipx/ipx.c,v
retrieving revision 1.19
diff -u -r1.19 ipx.c
--- sys/netipx/ipx.c	2000/12/08 21:50:49	1.19
+++ sys/netipx/ipx.c	2000/12/13 05:38:32
@@ -108,8 +108,11 @@
 		return (0);
 	}
 
-	if (p && (error = suser(p)) != 0)
-		return (error);
+	if (p) {
+		if ((error = cap_check(NULL, p, CAP_NET_ADMIN, 0)) != 0)
+			return (error);
+		suser_used(p);
+	}
 
 	switch (cmd) {
 	case SIOCAIFADDR:
Index: sys/netipx/ipx_pcb.c
===================================================================
RCS file: /home/ncvs/src/sys/netipx/ipx_pcb.c,v
retrieving revision 1.20
diff -u -r1.20 ipx_pcb.c
--- sys/netipx/ipx_pcb.c	2000/12/08 21:50:49	1.20
+++ sys/netipx/ipx_pcb.c	2000/12/13 05:40:34
@@ -98,9 +98,12 @@
 		u_short aport = ntohs(lport);
 		int error;
 
-		if (aport < IPXPORT_RESERVED &&
-		    p != NULL && (error = suser(p)) != 0)
-			return (error);
+		if (aport < IPXPORT_RESERVED && p != NULL) {
+			if ((error = cap_check(NULL, p, CAP_NET_BIND_SERVICE,
+			    0)) != 0)
+				return (error);
+			suser_used(p);
+		}
 		if (ipx_pcblookup(&zeroipx_addr, lport, 0))
 			return (EADDRINUSE);
 	}
Index: sys/netipx/ipx_usrreq.c
===================================================================
RCS file: /home/ncvs/src/sys/netipx/ipx_usrreq.c,v
retrieving revision 1.27
diff -u -r1.27 ipx_usrreq.c
--- sys/netipx/ipx_usrreq.c	2000/10/29 16:06:50	1.27
+++ sys/netipx/ipx_usrreq.c	2000/11/07 02:46:19
@@ -602,8 +602,11 @@
 	int s;
 	struct ipxpcb *ipxp = sotoipxpcb(so);
 
-	if (p != NULL && (error = suser(p)) != 0)
-		return (error);
+	if (p != NULL) {
+		if ((error = cap_check(NULL, p, CAP_NET_RAW, 0)) != 0)
+			return (error);
+		suser_used(error);
+	}
 	s = splnet();
 	error = ipx_pcballoc(so, &ipxrawpcb, p);
 	splx(s);
Index: sys/nfs/nfs_serv.c
===================================================================
RCS file: /home/ncvs/src/sys/nfs/nfs_serv.c,v
retrieving revision 1.98
diff -u -r1.98 nfs_serv.c
--- sys/nfs/nfs_serv.c	2000/12/21 21:44:24	1.98
+++ sys/nfs/nfs_serv.c	2001/01/05 17:42:28
@@ -1788,11 +1788,13 @@
 			/*
 			 * Handle SysV FIFO node special cases.  All other
 			 * devices require super user to access.
+			 *
+			 * XXX CAP_MKNOD seems to be the closest match.
 			 */
 			if (vap->va_type == VCHR && rdev == 0xffffffff)
 				vap->va_type = VFIFO;
                         if (vap->va_type != VFIFO &&
-                            (error = suser_xxx(cred, 0, 0))) {
+                            (error = cap_check(cred, NULL, CAP_MKNOD, 0))) {
 				goto nfsmreply0;
                         }
 			vap->va_rdev = rdev;
@@ -2004,7 +2006,10 @@
 		if (error)
 			NDFREE(&nd, NDF_ONLY_PNBUF);
 	} else {
-		if (vtyp != VFIFO && (error = suser_xxx(cred, 0, 0)))
+		/*
+		 * XXX CAP_MKNOD seems to be the closest match?
+		 */
+		if (vtyp != VFIFO && (error = cap_check(cred, NULL, CAP_MKNOD,			    0)))
 			goto out;
 		nqsrv_getl(nd.ni_dvp, ND_WRITE);
 
Index: sys/nfs/nfs_syscalls.c
===================================================================
RCS file: /home/ncvs/src/sys/nfs/nfs_syscalls.c,v
retrieving revision 1.64
diff -u -r1.64 nfs_syscalls.c
--- sys/nfs/nfs_syscalls.c	2000/12/21 21:44:24	1.64
+++ sys/nfs/nfs_syscalls.c	2001/01/05 17:42:29
@@ -154,10 +154,12 @@
 
 	/*
 	 * Must be super user
+	 * XXX CAP_SYS_ADMIN seems to be a catch all, is it right?
 	 */
-	error = suser(p);
+	error = cap_check(NULL, p, CAP_SYS_ADMIN, 0);
 	if(error)
 		return (error);
+	suser_used(p);
 	while (nfssvc_sockhead_flag & SLP_INIT) {
 		 nfssvc_sockhead_flag |= SLP_WANTINIT;
 		(void) tsleep((caddr_t)&nfssvc_sockhead, PSOCK, "nfsd init", 0);
Index: sys/pccard/pccard.c
===================================================================
RCS file: /home/ncvs/src/sys/pccard/pccard.c,v
retrieving revision 1.115
diff -u -r1.115 pccard.c
--- sys/pccard/pccard.c	2000/10/29 16:29:05	1.115
+++ sys/pccard/pccard.c	2000/11/07 02:46:52
@@ -507,8 +507,9 @@
 	 * At the very least, we only allow root to set the context.
 	 */
 	case PIOCSMEM:
-		if (suser(p))
-			return(EPERM);
+		if ((err = cap_check(NULL, p, CAP_SYS_ADMIN, 0)) != 0)
+			return(err);
+		suser_used(p);
 		if (slt->state != filled)
 			return(ENXIO);
 		s = ((struct mem_desc *)data)->window;
@@ -532,8 +533,9 @@
 	 * Set I/O port context.
 	 */
 	case PIOCSIO:
-		if (suser(p))
-			return(EPERM);
+		if ((err = cap_check(NULL, p, CAP_SYS_ADMIN, 0)) != 0)
+			return(err);
+		suser_used(p);
 		if (slt->state != filled)
 			return(ENXIO);
 		s = ((struct io_desc *)data)->window;
@@ -560,8 +562,9 @@
 				*(unsigned long *)data = pccard_mem;
 			break;
 		}
-		if (suser(p))
-			return(EPERM);
+		if ((err = cap_check(NULL, p, CAP_SYS_ADMIN, 0)) != 0)
+			return(err);
+		suser_used(p);
 		/*
 		 * Validate the memory by checking it against the I/O
 		 * memory range. It must also start on an aligned block size.
@@ -589,8 +592,9 @@
 	 * Allocate a driver to this slot.
 	 */
 	case PIOCSDRV:
-		if (suser(p))
-			return(EPERM);
+		if ((err = cap_check(NULL, p, CAP_SYS_ADMIN, 0)) != 0)
+			return(err);
+		suser_used(p);
 		err = allocate_driver(slt, (struct dev_desc *)data);
 		if (!err)
 			pccard_success_beep();
Index: sys/sys/mount.h
===================================================================
RCS file: /home/ncvs/src/sys/sys/mount.h,v
retrieving revision 1.99
diff -u -r1.99 mount.h
--- sys/sys/mount.h	2000/12/04 09:21:05	1.99
+++ sys/sys/mount.h	2000/12/13 05:40:51
@@ -37,6 +37,7 @@
 #ifndef _SYS_MOUNT_H_
 #define _SYS_MOUNT_H_
 
+#include <sys/capability.h>
 #include <sys/ucred.h>
 #include <sys/queue.h>
 #ifdef _KERNEL
Index: sys/sys/proc.h
===================================================================
RCS file: /home/ncvs/src/sys/sys/proc.h,v
retrieving revision 1.137
diff -u -r1.137 proc.h
--- sys/sys/proc.h	2000/12/23 19:43:10	1.137
+++ sys/sys/proc.h	2001/01/05 17:42:40
@@ -52,6 +52,7 @@
 #ifndef _KERNEL
 #include <sys/time.h>			/* For structs itimerval, timeval. */
 #endif
+#include <sys/capability.h>
 #include <sys/ucred.h>
 
 /*
@@ -333,6 +334,7 @@
 	uid_t	p_svuid;		/* Saved effective user id. */
 	gid_t	p_rgid;			/* Real group id. */
 	gid_t	p_svgid;		/* Saved effective group id. */
+	struct cap	p_cap;		/* Capabilities */
 	int	p_refcnt;		/* Number of references. */
 	struct	uidinfo *p_uidinfo;	/* Per uid resource consumption. */
 };
Index: sys/sys/systm.h
===================================================================
RCS file: /home/ncvs/src/sys/sys/systm.h,v
retrieving revision 1.131
diff -u -r1.131 systm.h
--- sys/sys/systm.h	2000/12/20 21:50:34	1.131
+++ sys/sys/systm.h	2001/01/05 17:42:41
@@ -47,6 +47,7 @@
 #include <sys/callout.h>
 
 extern int securelevel;		/* system security level (see init(8)) */
+extern int suser_permitted;	/* suser_xxx() is permitted to return 0 */
 
 extern int cold;		/* nonzero if we are doing a cold boot */
 extern const char *panicstr;	/* panic message */
Index: sys/sys/ucred.h
===================================================================
RCS file: /home/ncvs/src/sys/sys/ucred.h,v
retrieving revision 1.19
diff -u -r1.19 ucred.h
--- sys/sys/ucred.h	2000/11/30 19:09:47	1.19
+++ sys/sys/ucred.h	2000/12/13 05:40:53
@@ -50,6 +50,7 @@
 	uid_t	cr_uid;			/* effective user id */
 	short	cr_ngroups;		/* number of groups */
 	gid_t	cr_groups[NGROUPS];	/* groups */
+	struct cap	cr_cap;		/* capabilities */
 	struct	uidinfo *cr_uidinfo;	/* per uid resource consumption */
 	struct	mtx cr_mtx;		/* protect refcount */
 };
Index: sys/sys/user.h
===================================================================
RCS file: /home/ncvs/src/sys/sys/user.h,v
retrieving revision 1.26
diff -u -r1.26 user.h
--- sys/sys/user.h	2000/12/12 07:25:54	1.26
+++ sys/sys/user.h	2000/12/13 05:40:53
@@ -43,6 +43,7 @@
 #include <sys/errno.h>
 #include <sys/time.h>
 #include <sys/resource.h>
+#include <sys/capability.h>
 #include <sys/ucred.h>
 #include <sys/uio.h>
 #include <sys/proc.h>
Index: sys/sys/vnode.h
===================================================================
RCS file: /home/ncvs/src/sys/sys/vnode.h,v
retrieving revision 1.134
diff -u -r1.134 vnode.h
--- sys/sys/vnode.h	2000/12/26 19:41:37	1.134
+++ sys/sys/vnode.h	2001/01/05 17:42:42
@@ -532,6 +532,7 @@
 struct proc;
 struct stat;
 struct nstat;
+struct cap;
 struct ucred;
 struct uio;
 struct vattr;
